#include <stdio.h>
#include <unistd.h>

#include "prompt.h"
#include "plymouth.h"
#include "tpm.h"

int
main (int argc, char **argv)
{
    char *cryptsource = getenv ("cryptsource");
    char *crypttarget = getenv ("crypttarget");
    char prompt_text[1024];
    if (cryptsource && crypttarget)
        snprintf (prompt_text, 1024, "Unlocking the disk %s (%s)\nEnter passphrase", cryptsource, crypttarget);
    else
        snprintf (prompt_text, 1024, "Enter passphrase");

    /* Decrypt with a password */
    Buffer password;
    if (plymouth_running ())
        plymouth_prompt (prompt_text, &password);
    else
        prompt (prompt_text, &password);

    // FIXME: Hard-coded index
    Buffer dek;
    if (!tpm_read_nvram (0x60000000, password, 32, &dek))
        return EXIT_FAILURE;
    buffer_free (password);

    /* Write key to stdout for cryptsetup to read */
    int result = EXIT_SUCCESS;
    if (write (STDOUT_FILENO, dek.data, dek.length) != dek.length)
        result = EXIT_FAILURE;
    buffer_free (dek);

    return result;
}
