#include <stdio.h>
#include <termios.h>

#include "prompt.h"

// FIXME: Use Plymouth if available

void
prompt (const char *text, Buffer *buffer)
{
    struct termios orig_attr, result_attr;
    char *line = NULL;
    size_t n = 0;

    fprintf (stderr, "%s: ", text);

    /* Disable echoing of typed characters */
    tcgetattr (fileno (stdin), &orig_attr);
    result_attr = orig_attr;
    result_attr.c_lflag &= ~ECHO;
    tcsetattr (fileno (stdin), TCSAFLUSH, &result_attr);

    /* Read a line from the user */
    buffer->length = getline (&line, &n, stdin);
    buffer->data = (BYTE *) line;

    /* Remove trailing newline character */
    if (buffer->length > 0 && line[buffer->length - 1] == '\n')
    {
        line[buffer->length - 1] = '\0';
        buffer->length--;
    }

    /* Restore terminal echoing */
    tcsetattr (fileno (stdin), TCSAFLUSH, &orig_attr);

    fprintf (stderr, "\n");
}
